Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osg::TextureCubeMap Class Reference

TextureCubeMap state class which encapsulates OpenGL texture cubemap functionality. More...

Inheritance diagram for osg::TextureCubeMap:

[legend]
List of all members.

## Public Types
enum | Face { POSITIVE_X = 0, NEGATIVE_X = 1, POSITIVE_Y = 2, NEGATIVE_Y = 3, POSITIVE_Z = 4, NEGATIVE_Z = 5 }
## Public Member Functions
| TextureCubeMap ()
| TextureCubeMap (const TextureCubeMap &cm, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| Copy constructor using CopyOp to manage deep vs shallow copy.
| META_StateAttribute (osg, TextureCubeMap, TEXTURE)
virtual int | compare (const StateAttribute &rhs) const
| Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.
virtual GLenum | getTextureTarget () const
virtual void | setImage (unsigned int face, Image *image)
| Set the texture image for specified face.
virtual Image * | getImage (unsigned int face)
| Get the texture image for specified face.
virtual const Image * | getImage (unsigned int face) const
| Get the const texture image for specified face.
virtual unsigned int | getNumImages () const
| Get the number of images that can be assigned to the Texture.
unsigned int & | getModifiedCount (unsigned int face, unsigned int contextID) const
void | setTextureSize (int width, int height) const
| Set the texture width and height.
void | setTextureWidth (int width)
int | getTextureWidth () const
void | setTextureHeight (int height)
int | getTextureHeight () const
void | setSubloadCallback (SubloadCallback *cb)
SubloadCallback * | getSubloadCallback ()
const SubloadCallback * | getSubloadCallback () const
void | setNumMipmapLevels (unsigned int num) const
| Set the number of mip map levels the the texture has been created with.
unsigned int | getNumMipmapLevels () const
| Get the number of mip map levels the the texture has been created with.
void | copyTexSubImageCubeMap (State &state, int face, int xoffset, int yoffset, int x, int y, int width, int height)
| Copies a two-dimensional texture subimage, as per glCopyTexSubImage2D.
virtual void | apply (State &state) const
| On first apply (unless already compiled), create the mipmapped texture and bind it.
## Static Public Member Functions
Extensions * | getExtensions (unsigned int contextID, bool createIfNotInitalized)
| Function to call to get the extension of a specified context.
void | setExtensions (unsigned int contextID, Extensions *extensions)
| The setExtensions method allows users to override the extensions across graphics contexts.
## Protected Types
typedef buffered_value< unsigned int > | ImageModifiedCount
## Protected Member Functions
virtual | ~TextureCubeMap ()
bool | imagesValid () const
virtual void | computeInternalFormat () const
## Protected Attributes
ref_ptr< Image > | _images [6]
GLsizei | _textureWidth
GLsizei | _textureHeight
GLsizei | _numMipmapLevels
ref_ptr< SubloadCallback > | _subloadCallback
ImageModifiedCount | _modifiedCount [6]

## Detailed Description

TextureCubeMap state class which encapsulates OpenGL texture cubemap functionality.

## Member Typedef Documentation

typedef buffered_value<unsigned int> osg::TextureCubeMap::ImageModifiedCount`[protected]`

## Member Enumeration Documentation

enum osg::TextureCubeMap::Face

  | Enumeration values:
  POSITIVE_X |
  NEGATIVE_X |
  POSITIVE_Y |
  NEGATIVE_Y |
  POSITIVE_Z |
  NEGATIVE_Z |

## Constructor & Destructor Documentation

osg::TextureCubeMap::TextureCubeMap | ( |  | ) |

osg::TextureCubeMap::TextureCubeMap | ( | const TextureCubeMap & | cm,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY
| ) |

| Copy constructor using CopyOp to manage deep vs shallow copy.

virtual osg::TextureCubeMap::~TextureCubeMap | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

virtual void osg::TextureCubeMap::apply | ( | State & | state | ) | const`[virtual]`

| On first apply (unless already compiled), create the mipmapped texture and bind it. Subsequent apply will simple bind to texture. Implements osg::Texture.

virtual int osg::TextureCubeMap::compare | ( | const StateAttribute & | rhs | ) | const`[virtual]`

| Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs. Implements osg::StateAttribute.

virtual void osg::TextureCubeMap::computeInternalFormat | ( |  | ) | const`[protected, virtual]`

| Implements osg::Texture.

void osg::TextureCubeMap::copyTexSubImageCubeMap | ( | State & | state,
|  | int | face,
|  | int | xoffset,
|  | int | yoffset,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |

| Copies a two-dimensional texture subimage, as per glCopyTexSubImage2D. Updates a portion of an existing OpenGL texture object from the current OpenGL background framebuffer contents at position x, y with width width and height height. Loads framebuffer data into the texture using offsets xoffset and yoffset. width and height must be powers of two.

Extensions* osg::TextureCubeMap::getExtensions | ( | unsigned int | contextID,
|  | bool | createIfNotInitalized
| ) | `[static]`

| Function to call to get the extension of a specified context. If the Exentsion object for that context has not yet been created and the 'createIfNotInitalized' flag been set to false then returns NULL. If 'createIfNotInitalized' is true then the Extensions object is automatically created. However, in this case the extension object will only be created with the graphics context associated with ContextID. Reimplemented from osg::Texture.

virtual const Image* osg::TextureCubeMap::getImage | ( | unsigned int | face | ) | const`[virtual]`

| Get the const texture image for specified face. Implements osg::Texture.

virtual Image* osg::TextureCubeMap::getImage | ( | unsigned int | face | ) | `[virtual]`

| Get the texture image for specified face. Implements osg::Texture.

unsigned int& osg::TextureCubeMap::getModifiedCount | ( | unsigned int | face,
|  | unsigned int | contextID
| ) | const`[inline]`

virtual unsigned int osg::TextureCubeMap::getNumImages | ( |  | ) | const`[inline, virtual]`

| Get the number of images that can be assigned to the Texture. Implements osg::Texture.

unsigned int osg::TextureCubeMap::getNumMipmapLevels | ( |  | ) | const`[inline]`

| Get the number of mip map levels the the texture has been created with.

const SubloadCallback* osg::TextureCubeMap::getSubloadCallback | ( |  | ) | const`[inline]`

SubloadCallback* osg::TextureCubeMap::getSubloadCallback | ( |  | ) | `[inline]`

int osg::TextureCubeMap::getTextureHeight | ( |  | ) | const`[inline]`

virtual GLenum osg::TextureCubeMap::getTextureTarget | ( |  | ) | const`[inline, virtual]`

| Implements osg::Texture.

int osg::TextureCubeMap::getTextureWidth | ( |  | ) | const`[inline]`

bool osg::TextureCubeMap::imagesValid | ( |  | ) | const`[protected]`

osg::TextureCubeMap::META_StateAttribute | ( | osg | ,
|  | TextureCubeMap | ,
|  | TEXTURE |
| ) |

void osg::TextureCubeMap::setExtensions | ( | unsigned int | contextID,
|  | Extensions * | extensions
| ) | `[static]`

| The setExtensions method allows users to override the extensions across graphics contexts. Typically used when you have different extensions supported across graphics pipes but need to ensure that they all use the same low common denominator extensions. Reimplemented from osg::Texture.

virtual void osg::TextureCubeMap::setImage | ( | unsigned int | face,
|  | Image * | image
| ) | `[virtual]`

| Set the texture image for specified face. Implements osg::Texture.

void osg::TextureCubeMap::setNumMipmapLevels | ( | unsigned int | num | ) | const`[inline]`

| Set the number of mip map levels the the texture has been created with. Should only be called within an osg::Texuture::apply() and custom OpenGL texture load.

void osg::TextureCubeMap::setSubloadCallback | ( | SubloadCallback * | cb | ) | `[inline]`

void osg::TextureCubeMap::setTextureHeight | ( | int | height | ) | `[inline]`

void osg::TextureCubeMap::setTextureSize | ( | int | width,
|  | int | height
| ) | const`[inline]`

| Set the texture width and height. If width or height are zero then the repsective size value is calculated from the source image sizes.

void osg::TextureCubeMap::setTextureWidth | ( | int | width | ) | `[inline]`

## Member Data Documentation

ref_ptr<Image> osg::TextureCubeMap::_images[6]`[protected]`

ImageModifiedCount osg::TextureCubeMap::_modifiedCount[6]`[mutable, protected]`

GLsizei osg::TextureCubeMap::_numMipmapLevels`[mutable, protected]`

ref_ptr<SubloadCallback> osg::TextureCubeMap::_subloadCallback`[protected]`

GLsizei osg::TextureCubeMap::_textureHeight`[mutable, protected]`

GLsizei osg::TextureCubeMap::_textureWidth`[mutable, protected]`

The documentation for this class was generated from the following file:

- TextureCubeMap